#!/usr/bin/perl -w
# 
# sb::Plugin::LinkStyleFormat - Plugin Module for Serene Bach
# - Written by Gin-Lime / published on 2006-06-01
# -- `Serene Bach' is written by T.Otani
# --   Copyright (C) 2005- SimpleBoxes/SerendipityNZ.

package sb::Plugin::LinkStyleFormat;
# ==================================================
# // initialization for plugin
# ==================================================
use sb::Plugin ();
sb::Plugin->register_plugin(
	'lang' => {
		'ja' => 'euc',
		'en' => 'ascii',
	},
	'text' => {
		'type'    => 'text format, admin, cms',
		'name'    => 'LinkStyleFormat',
		'text'    => 'Provides formats specialized for linking',
		'author'  => 'Gin-Lime',
		'detail'  => 'http://www.emeraldshell.com/sb/',
		'version' => '0.04',
		'publish' => 'yes',	# ץ饰ꥹȤΤγĥʸ/
	},
	'file' => 'linkformat.txt',
	'data' => 1,
);
# ƥȥեޥåȥץ饰ȤϿ
sb::Plugin->register_text_filter(
	'name'     => 'LinkFormat',
	'callback' => \&sb::TextFormat::linkformat::format,
);
# cms ѵץ饰ȤϿ
sb::Plugin->register_content_module(
	'type'     => 'entry',
	'callback' => \&sb::TextFormat::linkformat::content,
	'field'    => 'body_text',
	'name'     => 'sb::TextFormat::linkformat::content',
);
# cms  main ץ饰ȤϿ
sb::Plugin->register_content_module(
	'type'     => 'main',
	'callback' => \&sb::TextFormat::linkformat::_main,
	'field'    => '_main',
	'name'     => 'sb::TextFormat::linkformat::_main',
);
# adminѥץ饰ȤϿ
sb::Plugin->register_admin_module(
	'mode'   => 'linkformat',
	'level'  => 2,
	'module' => 'sb::Admin::LinkFormat',
);
package sb::TextFormat::linkformat;
use sb::Config ();
# ==================================================
# // declaration for constant value
# ==================================================
# ŷեꥨȤ URL
sub LINK_RAKUTEN_AFFILIATE (){ 'http://pt.afl.rakuten.co.jp/c/' };
# ŷ֥åθ URL
sub LINK_RAKUTEN_BOOKS (){ 'http://esearch.rakuten.co.jp/rms/sd/esearch/vc?sv=30&sitem=' };
# Google θ URL
sub LINK_GOOGLE (){ 'http://www.google.com/search?lr=lang_ja&amp;q=' };
# ϤƤʥɥ URL
sub LINK_HATENA (){ 'http://d.hatena.ne.jp/keyword/' };

# Amazon θʤɤδ URL
sub LINK_AMAZON (){ 'http://www.amazon.co.jp/exec/obidos/redirect?link_code=ur2' };

# Wikipedia ܸǤΥɥ URL
sub LINK_WIKIPEDIA (){ 'http://ja.wikipedia.org/wiki/' };
# ==================================================
# // declaration for class member
# ==================================================
my $mAwsId = '';
my $mMailAdr = '';
my $mIsMob = 0;
# ==================================================
# // functions for main
# ==================================================
sub _main {
	my $cms = shift;
	my %var = @_;
	if ($var{'mode'} eq 'mob') {
		my $user = $var{'user'}->{0};
		$mAwsId   = &_check_awsid($user->id) if ($mAwsId eq '');
		$mMailAdr = &_check_mailadr($user->id) if ($mMailAdr eq '');
		$mIsMob = 1;
	}
	return &sb::App::Feed::_common_parts($cms,%var);
}
# ==================================================
# // functions for content
# ==================================================
sub content { # ʸ³
	my $cms   = shift;
	my $entry = shift;
	my %var   = @_;
	if ($entry->form eq 'LinkFormat') { # Link Style Format
		$mAwsId   = &_check_awsid($entry->auth) if ($mAwsId eq '');
		$mMailAdr = &_check_mailadr($entry->auth) if ($mMailAdr eq '');
		$mIsMob = 1 if($var{'mode'} eq 'mob');
		if ($entry->body ne '') { # ʸ
			$body = $entry->formated_body;
			$body .= '<a id="sequel"></a>' if ($entry->more ne '' and $var{'mode'} eq 'ent');
		}
		if ($entry->more ne '') { # ³
			my $permalink = &sb::Content::Entry::_permalink($entry,$var{'cat'},'more',$var{'mode'});
			$more = ($var{'mode'} eq 'ent') 
			      ? $entry->formated_more 
			      : '<a href="' . $permalink . '">' . $var{'lang'}->string('parts_sequel') . '</a>';
		}
		$cms->tag('entry_description'=>$body) if ($body ne '');
		$cms->tag('entry_sequel'=>$more) if ($more ne '');
		$cms->tag('entry_excerpt'=>$entry->sum);
	} else { # other format
		&sb::Content::Entry::_body_text($cms,$entry,%var);
	}
}
# ==================================================
# // private functions - other utilities
# ==================================================
sub _check_awsid { # ޥ󥢥 ID ɤ߹
	my $id = shift;
	my $user = sb::Data->load('User','id'=>$id);
	return ($user and $user->aws ne '') ? $user->aws : 'emeraldshell-22';
}
sub _check_mailadr { # ᡼륢ɥ쥹ɤ߹
	my $id = shift;
	my $user = sb::Data->load('User','id'=>$id);
	return ($user and $user->mail ne '') ? $user->mail : '';
}
# ==================================================
# // functions for text format
# ==================================================
use sb::Text ();
sub format { # ƥȥեޥåȥᥤ
	my $text = shift; # ϥѥ᡼
	$text = sb::Text->entitize($text);
	$text = &_link_format($text);
	$text = sb::Text->detitize($text);
	return($text);
}
# ==================================================
# // private functions - text utilities
# ==================================================
use sb::Language ();
sub _link_format {
	my $text = shift;	# ϥѥ᡼
	my $out = '';	# ϥѥ᡼
	my @buf = split("\n",$text);
	my @out = ();
	my $lang = sb::Language->get;
	my $code = $lang->charcode;
	my $set_data = sb::Plugin->get_data;
	my @settings = split('<>',$set_data->setting);
	my $auto_break = ($settings[0] ne '') ? $settings[0] : &sb::Admin::LinkFormat::AUTO_BREAK;
	my $break_appear = ($settings[1] ne '') ? $settings[1] : &sb::Admin::LinkFormat::BREAK_APPEAR;
	my @strings = split('<>',$set_data->text);
	my $link_target = ($strings[0] ne '') ? sb::Text->detitize($strings[0]) : &sb::Admin::LinkFormat::LINK_TARGET;
	my $rakuten_affiliate_id = ($strings[1] ne '') ? sb::Text->detitize($strings[1]) : &sb::Admin::LinkFormat::RAKUTEN_AFFILIATE_ID;
	my $link_wiki = ($strings[2] ne '') ? sb::Text->detitize($strings[2]) : &sb::Admin::LinkFormat::LINK_WIKI;
	my $wiki_charcode = ($strings[3] ne '') ? sb::Text->detitize($strings[3]) : &sb::Admin::LinkFormat::WIKI_CHARCODE;
	foreach my $line (@buf) {
		while(index($line, '[[') > -1) {
			if($line =~ /^(.*?)\[\[([^\[]+?)\]\](.*?)$/i) {
				my ($former,$chkstr,$latter) = ($1,$2,$3);
				my $linkstr = my $adrstr = $chkstr;
				my $titlestr = '';
				if(index($chkstr, '||') > -1) {
					my $tmpsplit = '';
					($tmpsplit,$titlestr) = split(/\|\|/,$chkstr);
					$linkstr = $adrstr = $chkstr = $tmpsplit;
				}
				my $targetmode = 1;
				my $linkOk = 1;
				my $linkres = '';
				if(index($chkstr, '::') > -1) {
					($linkstr,$adrstr) = split('::',$chkstr);
					my $tmpadrchk = '';
					if($adrstr eq '') {
						$linkOk = 0;
					} elsif($adrstr =~ /^ASIN\//i) { # Amazon 
						$tmpadrchk = $adrstr;
						$tmpadrchk =~ s/^ASIN\///i;
						if($tmpadrchk eq '') {
							$linkOk = 0;
						} else {
							$tmpadrchk =~ s/\/$//; # ʸˡ/פդƤƤ
							$adrstr = LINK_AMAZON;
							$adrstr .= '&tag=' . $mAwsId if($mAwsId ne '');
							$adrstr .= '&path=ASIN%2F' . $tmpadrchk . '%2F';
						}
					} elsif($adrstr =~ /^aa?s\//i) { # Amazon ʥȤޤ
						$adrstr =~ s/&lt;/</g;
						$adrstr =~ s/&gt;/>/g;
						$tmpadrchk = $adrstr;
						$tmpadrchk =~ s/^aa?s\///i;
						$tmpadrchk =~ s/^<[^<]+?>//;
						if($tmpadrchk eq '') {
							$linkOk = 0;
						} else {
							my $amztag = '';
							if($adrstr =~ /^aas\//i) {
								$amztag = '&tag=' . $mAwsId;
							}
							$adrstr =~ s/^aa?s\///i;
							my $asmode = 'blended';
							if($adrstr =~ /^\<([^<]+?)\>(.*?)$/) {
								$asmode = $1;
								$adrstr = $2;
								if(($asmode eq '') || ($asmode eq 'blended')) {
									$asmode = 'blended';
								} elsif($adrstr !~ /\-(jp|us)$/) {
									$asmode .= '-jp';
								}
							}
							if($titlestr eq '') {
								my $asmodestr = '';
								$asmodestr = sprintf($lang->string('parts_linkformat_title_amazongenre'),$lang->string('parts_linkformat_title_amazon' . $asmode)) if(($asmode ne 'blended') && ($lang->string('parts_linkformat_title_amazon' . $asmode) ne ''));
								$titlestr = sprintf($lang->string('parts_linkformat_title_amazonsearch'),$asmodestr,$tmpadrchk);
							}
							$adrstr = &_amazon_search_string($tmpadrchk,$code);
							$adrstr = LINK_AMAZON . $amztag . '&path=external-search%3Fsearch-type=ss%26index=' . $asmode . '%26keyword=' . $adrstr;
						}
					} elsif($adrstr =~ /^ra\//i) { # ŷեꥨ
						$adrstr =~ s/^ra\///i;
						if($adrstr eq '') {
							$linkOk = 0;
						} else {
							if($rakuten_affiliate_id) {
								$adrstr =~ s/\:/\%3a/g;
								$adrstr =~ s/\//\%2f/g;
								$adrstr =~ s/#/\%23/g;
								$adrstr = LINK_RAKUTEN_AFFILIATE . $rakuten_affiliate_id . '/?url=' . $adrstr;
							}
						}
					} elsif($adrstr =~ /^rb\//i) { # ŷ֥å
						$adrstr =~ s/^rb\///i;
						if($adrstr eq '') {
							$linkOk = 0;
						} else {
							if($titlestr eq '') {
								$titlestr = sprintf($lang->string('parts_linkformat_title_rakutenbooks'),$adrstr);
							}
							$adrstr = $lang->convert($adrstr,'euc') if ($code ne 'euc');
							$adrstr = &_url_encode($adrstr);
							$adrstr = LINK_RAKUTEN_BOOKS . $adrstr;
						}
					} elsif($adrstr =~ /^gs\//i) { # Google 
						$adrstr =~ s/^gs\///i;
						if($adrstr eq '') {
							$linkOk = 0;
						} else {
							if($titlestr eq '') {
								$titlestr = sprintf($lang->string('parts_linkformat_title_googlesearch'),$adrstr);
							}
							$adrstr = $lang->convert($adrstr,'utf8') if ($code ne 'utf8');
							$adrstr = &_url_encode($adrstr);
							$adrstr = LINK_GOOGLE . $adrstr;
						}
					} elsif($adrstr =~ /^hatena\//i) { # ϤƤʥɥ
						$adrstr =~ s/^hatena\///i;
						if($adrstr eq '') {
							$linkOk = 0;
						} else {
							if($titlestr eq '') {
								$titlestr = sprintf($lang->string('parts_linkformat_title_hatena'),$adrstr);
							}
							$adrstr = $lang->convert($adrstr,'euc') if ($code ne 'euc');
							$adrstr = &_url_encode($adrstr);
							$adrstr = LINK_HATENA . $adrstr;
						}
					} elsif($adrstr =~ /^wp\//i) { # Wikipedia ɥ
						$adrstr =~ s/^wp\///i;
						if($adrstr eq '') {
							$linkOk = 0;
						} else {
							if($titlestr eq '') {
								$titlestr = sprintf($lang->string('parts_linkformat_title_wikipedia'),$adrstr);
							}
							$adrstr =~ s/\s/_/g;
							$adrstr = $lang->convert($adrstr,'utf8') if ($code ne 'utf8');
							$adrstr = &_url_encode($adrstr);
							$adrstr = LINK_WIKIPEDIA . $adrstr;
						}
					} elsif($adrstr =~ /^mail\/self$/i) { # 桼Υ᡼륢ɥ쥹
						if($mMailAdr eq '') {
							$linkOk = 0;
						} else {
							$adrstr = &_email_entitize($mMailAdr, 'mailto', 1);
							$targetmode = 0;
						}
					} elsif($adrstr =~ /^(https?|mailto|callto)\:/) { # URL᡼륢ɥ쥹
						if($adrstr =~ /^mailto\:/) {
							$adrstr =~ s/^mailto\://;
							if($adrstr eq '') {
								$linkOk = 0;
							}
							$adrstr = &_email_entitize($adrstr, 'mailto', 1) if ($linkOk);
						}
					} elsif($adrstr =~ /^\#/) { # 󥫡
						$targetmode = 0;
					} else { # Wiki Ϣȡ褬ۤʤ
						if($link_wiki eq '') {
							$linkOk = 0;
						} else {
							$adrstr = &_wiki_connect($adrstr, $link_wiki, $code, $wiki_charcode);
						}
					}
				} else {
					if($adrstr =~ /^(https?|mailto)\:/) { # URL᡼륢ɥ쥹
						if($adrstr =~ /^mailto\:/) { # ᡼륢ɥ쥹ξ
							$adrstr =~ s/^mailto\://;
							if($adrstr eq '') {
								$linkOk = 0;
							}
							if ($linkOk) {
								$adrstr = &_email_entitize($adrstr, 'mailto', 1);
								$linkstr =~ s/^mailto\://;
								$linkstr = &_email_entitize($linkstr, '', 1);
							}
						}
					} else { # Wiki Ϣȡ褬Ʊ
						if($link_wiki eq '') {
							$linkOk = 0;
						} else {
							$adrstr = &_wiki_connect($adrstr, $link_wiki, $code, $wiki_charcode);
						}
					}
				}
				if($linkOk) {
					if($link_target eq '') { $targetmode = 0;}
					$linkres = &_text_to_link($linkstr,$adrstr,$titlestr,$targetmode,$link_target);
				} else { # ɥ쥹ϥ󥯤ʤ
					$linkres = $linkstr;
				}
				$line = join('',$former,$linkres,$latter);
			} else { # Ĥ˺[פο¿Ȥˤ̵¥롼ɻ
				$line =~ s/\[\[//g;
				$line =~ s/\]\]//g;
			}
		}
		if($auto_break) { # ʰŪ˼ư
			$line = &_set_break($line);
		}
		if((!$mIsMob) && ($break_appear)) { # Ԥ̤ȿǤʤк
			if($line eq '<br />') { $line = '</p><p class="entry_contents"><br />';}
		}
		push(@out,$line);
	}
	$out = join("\n",@out);
	if((!$mIsMob) && ($break_appear)) { # Ԥ̤ȿǤʤк
		$out = '<p class="entry_contents">' . $out . '</p>';
	}
	if($text eq '') {
		$out = '';
	}
	return($out);
}

# Wiki ϢȤζ̽
sub _wiki_connect {
	my $str  = shift;
	my $adr  = shift;
	my $code = shift;
	my $wikicode = shift;
	$str = sb::Language->get->convert($str,$wikicode) if ($code ne $wikicode);
	$str = &_url_encode($str);
	$str = $adr . '?' . $str;
	return($str);
}

# 󥯤˲ù
sub _text_to_link {
	my $str = shift;
	my $address = shift;
	my $title = shift;
	my $mode = shift;
	my $att_target = shift;
	my $text = my $target = '';
	if($mode) {
		$target = ' target="' . $att_target . '"';
	}
	if($title ne '') {
		my $ap = '';
		$title =~ s/&lt;/</g;
		$title =~ s/&gt;/>/g;
		if($title =~ /^\<([^<]+?)\>(.*?)$/) {
			my $tmpmark = $1;
			$title = $2;
			if($tmpmark eq 'np') {
				$ap = ' class="AP-noPopup"';
			} elsif($tmpmark =~ /^ab\:(.*?)$/) {
				$ap = ' ap:banner="' . $1 . '"';
			}
		}
		$title = ' title="' . $title . '"' . $ap;
	}
	$text = '<a href="' . $address . '"' . $title . $target . '>' . $str . '</a>';
	return($text);
}

# ᡼륢ɥ쥹Υƥƥ
sub _email_entitize {
	my $email = shift;
	my $job = shift;
	my $random = shift;
	my $res = '';
	if($job eq 'mailto') {
		$email = 'mailto:' . $email;
	}
	for ( 0 .. length($email)-1 ) {
		my $rndFlag = 1;
		if($random) {
			$rndFlag = int(rand(3));
		}
		my $target = substr ( $email , $_ , 1 );
		if((!$rndFlag) && ($target eq '@')) {
			$rndFlag = 1;
		}
		if($rndFlag == 1) {
			$res .= '&#' . ord ($target) . ';';
		} elsif($rndFlag == 2) {
			$res .= '&#x' . sprintf("%x",ord ($target)) . ';';
		} else {
			$res .= $target;
		}
	}
	return($res);
}

# Ԥɲ
sub _set_break {
	my $text = shift;
	if(($text !~ /^<\/?ul>/i) && ($text !~ /<\/(p|blockquote|ul|li)>$/i) && ($text !~ /<br( \/)?>$/i)) {
		$text .= '<br />';
	}
	return($text);
}

# URL 󥳡
sub _url_encode {
	my $text = shift;
	$text =~ s/(\W)/'%' . unpack('H2', $1)/eg;
	return($text);
}

# Amazon ʸ
sub _amazon_search_string {
	my $text = shift;
	my $code = shift;
	if($text ne '') {
		my @tmp = ();
		$text = sb::Language->get->convert($text,'utf8') if ($code ne 'utf8');
		$text = &_url_encode($text);
		$text =~ s/\%/\%25/g;
		$text = uc($text);
	}
	return($text);
}
package sb::Admin::LinkFormat;
use sb::Text ();
use vars qw( @ISA );
use sb::Interface ();
use sb::TemplateManager ();
@ISA = qw( sb::App::Admin );
# ==================================================
# // declaration for constant value
# ==================================================
sub TEMPLATE  (){ 'linkformat.html' };
# ưԤβݡ1:ưԤ/0:ưԤʤ
sub AUTO_BREAK (){ '1' };
# CSS ԹǲԤ̤ȿǤʤIE к1:к¹/0:кϻѤʤ
sub BREAK_APPEAR (){ '0' };
# 󥯥å
# åȻꤷʤ϶ˤ
sub LINK_TARGET (){ '_blank' };
# ŷեꥨȤ ID ʸ
# 嵭եꥨ URL θˤʸ󡣥å/ˤϴޤʤ
sub RAKUTEN_AFFILIATE_ID (){ '' };
# ϢȤ Wiki Υɥ쥹
sub LINK_WIKI (){ '' };
# ϢȤ Wiki ʸɡsjis/euc/jis/ucs2/utf8
sub WIKI_CHARCODE (){ 'euc' };
# ==================================================
# // public functions - callback
# ==================================================
sub callback {
	my $self = shift;
	return ( $self->{'regi'} ) 
		? $self->_save_setting(@_)
		: $self->_show_setting(@_);
}
# ==================================================
# // private functions - main routine
# ==================================================
sub _save_setting {
	my $self = shift;
	my $cgi  = sb::Interface->get;
	# ǡμ
	my $data = sb::Plugin->get_data;
	# μ
	$data->setting($cgi->value('auto_break') . '<>' . $cgi->value('break_appear'));
	$data->text(sb::Text->entitize($cgi->value('link_target')) . '<>' . sb::Text->entitize($cgi->value('rakuten_affiliate_id')) . '<>' . sb::Text->entitize($cgi->value('link_wiki')) . '<>' . $cgi->value('wiki_charcode'));
	# ǡ¸
	sb::Plugin->set_data('data' => $data);
	# ¸λåɽ
	my $lang = sb::Language->get;
	my $msg = $lang->string('parts_confcomp');
	$msg .= $lang->string('parts_needmake');
	$msg .= sprintf($lang->string('parts_link_bld'),&sb::App::Admin::get_script_path);
	return $self->_show_setting('message'=>$msg);
}
sub _show_setting {
	my $self = shift;
	my %param = ('message' => '', @_);
	my $cms  = sb::TemplateManager->new(sb::Plugin->load_template('file' => TEMPLATE));
	my $set_data = sb::Plugin->get_data;
	my @settings = split('<>',$set_data->setting);
	my $auto_break = ($settings[0] ne '') ? $settings[0] : AUTO_BREAK;
	my $break_appear = ($settings[1] ne '') ? $settings[1] : BREAK_APPEAR;
	my @strings = split('<>',$set_data->text);
	my $link_target = ($strings[0] ne '') ? $strings[0] : LINK_TARGET;
	my $rakuten_affiliate_id = ($strings[1] ne '') ? $strings[1] : RAKUTEN_AFFILIATE_ID;
	my $link_wiki = ($strings[2] ne '') ? $strings[2] : LINK_WIKI;
	my $wiki_charcode = ($strings[3] ne '') ? $strings[3] : WIKI_CHARCODE;

	# ȼͤ
	$cms->num(0);
	$cms->tag('sb_linkformat_auto_break_0' =>
	          (!$auto_break) ? ' selected' : '' );
	$cms->tag('sb_linkformat_auto_break_1' =>
	          ($auto_break) ? ' selected' : '' );
	$cms->tag('sb_linkformat_break_appear_0' =>
	          (!$break_appear) ? ' selected' : '' );
	$cms->tag('sb_linkformat_break_appear_1' =>
	          ($break_appear) ? ' selected' : '' );
	$cms->tag('sb_linkformat_link_target' => $link_target);
	$cms->tag('sb_linkformat_rakuten_affiliate_id' => $rakuten_affiliate_id);
	$cms->tag('sb_linkformat_link_wiki' => $link_wiki);
	$cms->tag('sb_linkformat_wiki_charcode_0' =>
	          ($wiki_charcode eq 'sjis') ? ' selected' : '' );
	$cms->tag('sb_linkformat_wiki_charcode_1' =>
	          ($wiki_charcode eq 'euc') ? ' selected' : '' );
	$cms->tag('sb_linkformat_wiki_charcode_2' =>
	          ($wiki_charcode eq 'jis') ? ' selected' : '' );
	$cms->tag('sb_linkformat_wiki_charcode_3' =>
	          ($wiki_charcode eq 'ucs2') ? ' selected' : '' );
	$cms->tag('sb_linkformat_wiki_charcode_4' =>
	          ($wiki_charcode eq 'utf8') ? ' selected' : '' );

	# åɽ
	if ($param{'message'} ne '') {
		$cms->num(0);
		$cms->tag('sb_process_message' => $param{'message'});
		$cms->block('sb_process_message' => 1);
	}

	# ̤ɽ
	return sb::Interface->get->head('type'=>'text/html') . $self->set_main($cms->output);
}

1;
# require 뤿Τޤʤ
__END__

==== Υץ饰ˤĤ ========================================
εˡǵҤ󥯤ưŪ˥եޥåȤץ饰Ǥ

ưԤԤޤѹǽˡ
ξ硢ʲΥǻϤޤ/ԤˤϲԤʤ褦ˤʤä
ޤΤǡեޥåȤ֤Τޤޡפˤ <p></p> ԽƤ
ǤƳ䤹ʤäƤޤ

ưԤʤƬΥʸġ
<ul>
</ul>

ưԤʤΥʸġ
<br> ޤ <br />
</p>
</blockquote>
</ul>
</li>

 
֥饦ˤäơCSS ԹǲԤ̤ȿǤʤ2 ԰ʾ
ζԤäȤˡԿȥ֥饦Ǥθܤפʤˤ褦
Ȥ硢ܤΡCSS ԹǲԤ̤ȿǤʤ
פк¹ԤפꤷǡCSS ƥץ졼Ȥ˰ʲ
ɲäƤ

p.entry_contents {
	margin-top:0px;
	margin-bottom:0px;
}

 
κ桼˥ ID ꤵƤʤ硢ASIN/
ޤϡaas/פѤȡץ饰ԤΥ ID
emeraldshell-22פѤޤ
λ


==== 󥯥եޥå ============================================
󥯤ϰʲΥ롼ǵҤޤ

Wiki Ϣ
ꤷ Wiki ʸΥڡ˥פޤ
[[ʸ]]
ʸʸ㤦ΤˤϡҤʲΤ褦
ѹޤ
[[ʥʸ::ʸ]]

㡧
[[Serene Bach ץ饰]]
[[ʥץ饰⤢ޤ::Serene Bach ץ饰]]

ʤWiki Υɥ쥹ҤƤʤϡεˡ̵ˤʤ
ޤ

Amazon 
Amazon ξʥڡΥ󥯤ĥޤ
ξ硢ʸ ASIN/ Ϥޤɬפޤ
桼  ID ꤵƤ硢ưŪ˥
ȥ󥯤ˤʤޤ
[[ʥʸ::ASIN/ASIN ɡ]]

㡧
[[硼󥯤ζ::ASIN/B0009DC7XQ]]
ASIN ɤˡ/פäƤꤢޤ
[[硼󥯤ζ::ASIN/B0009DC7XQ/]]

Amazon 
Amazon θ̤˥󥯤ĥޤ
ξ硢ʸ as/ Ϥޤɬפꡢʸ򤽤
ޤ޵Ҥޤ
[[ʥʸ::as/ʸʸ]]
ޤꤹ硢ʸ˥Υɤ <>
ǰϤǵҤޤ
[[ʥʸ::as/<ʥ>ʸʸ]]
̤˥ ID ղä뤳ȤǤޤ
ξ硢ʸ aas/ Ϥޤɬפޤ
[[ʥʸ::aas/ʸʸ]]
[[ʥʸ::aas/<ʥ>ʸʸ]]

㡧
[[ιʱǲ::as/硼󥯤ζ]]
[[ڤ⤪::as/<music>硼󥯤ζ]]
[[ιʱǲ::aas/硼󥯤ζ]]
[[ιʱǲ::aas/<dvd>硼󥯤ζ]]

Amazon 륳ɡνʳϡ-jpפάǽ
½books-jp
νbooks-us
쥯ȥ˥electronics-jp
ۡåkitchen-jp
ݥԥ顼ڡmusic-jp
饷åclassical-jp
DVDdvd-jp
ӥǥvhs-jp
եȥsoftware-jp
TV ࡧvideogames-jp
ۥӡtoys-jp
ݡġsporting-goods-jp

ŷեꥨ
ŷեꥨȤΥ󥯤ĥޤ
ξ硢ʸ ra/ Ϥޤɬפޤ
襢ɥ쥹ϡоŹ/ʤΥɥ쥹ˤʤޤ
[[ʥʸ::ra/襢ɥ쥹]]

㡧
[[Ϥ::ra/http://www.rakuten.ne.jp/gold/nuts/]]
[[äǤ::ra/http://www.rakuten.co.jp/nuts/427131/618669/]]

ʤŷեꥨȤ ID ꤵƤʤ硢̾Υ󥯤
ʤޤ

ŷ֥å
ŷ֥åθ̤˥󥯤ĥޤ
ξ硢ʸ rb/ Ϥޤɬפꡢʸ򤽤
ޤ޵Ҥޤ
[[ʥʸ::rb/ʸʸ]]

㡧
[[򤤥饷åޥ::rb/Τᥫ󥿡ӥ]]

Google 
Google θ̤˥󥯤ĥޤ
ξ硢ʸ gs/ Ϥޤɬפꡢʸ򤽤
ޤ޵Ҥޤ
[[ʥʸ::gs/ʸʸ]]

㡧
[[Google ͤ˿֤Ƥߤ::gs/ Ź]]

ϤƤʥ
֤ϤƤʡפΥɤ˥󥯤ĥޤ
ξ硢ʸ hatena/ Ϥޤɬפꡢ
ʸ򤽤Τޤ޵Ҥޤ
[[ʥʸ::hatena/ʥʸ]]

㡧
[[ϤƤ::hatena/ϤƤ]]

Wikipedia ܸ
Wikipedia ܸǡפΥڡ˥󥯤ĥޤ
ξ硢ʸ wp/ Ϥޤɬפꡢڡ̾ʸ
Τޤ޵Ҥޤ
[[ʥʸ::wp/ʥڡ̾ʸ]]

㡧
[[饤ɴʻŵ::wp/ڥǥ]]

桼Υ᡼륢ɥ쥹
桼Υ᡼륢ɥ쥹˼ư󥯤ޤ
[[ʥʸ::mail/self]]

㡧
[[᡼::mail/self]]

¾̾
http:https:mailto: ΥץȥʸǻϤޤ URL ޤϥ᡼
ɥ쥹˥󥯤ĥޤޤSkype  callto: ץȥ
Ǥޤ
[[ʥʸ::URL᡼륢ɥ쥹]]

㡧
[[sbȯ::http://serennz.cool.ne.jp/sblog/]]
[[ᥤߥ::mailto:webmaster@emeraldshell.com]]

ʸά뤳ȤǤޤξ URL ᡼륢ɥ
ΤߤɽޤǤϡcallto: ץȥϻѤǤޤ
㡧
[[http://serennz.cool.ne.jp/sblog/]]
[[mailto:webmaster@emeraldshell.com]]

title °դ
󥯤 title °դ硢[[  ]] ʸκǸ
|| ǻϤޤʸդޤ
ϡ嵭Τ٤ƤΥ󥯥פŬѤǤޤ

㡧
[[Serene Bach ץ饰||Serene Bach ѤΥץ饰Ƥޤ]]
[[硼󥯤ζ::ASIN/B0009DC7XQ||ƥ֥󡦥󥰤ο;Τη]]

ϤΥ󥯤Ǥϡtitle °λ򤷤ʤˡGoogle ֡ס
Τ褦ʷǸоݤ title °˼ưꤵޤ

ʤߤȤߤΡ֤줳ݥåץåס
http://www.remus.dti.ne.jp/~a-satomi/bunsyorou/ArekorePopup.htmlˤ
Ѥ硢ʲɲõˡѤǤޤ

ap:banner °
|| ľ <ab:ʥХʡ URL> դʸ򵭽Ҥ뤳Ȥǡap:banner
°ѤǤޤ

㡧
[[ܤ굻::http://www.emeraldshell.com/||<ab:http://www.emeraldshell.com/sb/template/giken_banner.gif>Serene Bach Υץ饰Ƥޤ]]
[[̼̼Ź뤭::http://www.remus.dti.ne.jp/~a-satomi/||<ab:http://www.remus.dti.ne.jp/~a-satomi/common/img/banner/nyan2h_ban.png>֤줳ݥåץåספ줿ߤȤߤΥȤǤ]]

AP-noPopup 饹
|| ľ <np> դʸ򵭽Ҥ뤳ȤǡAP-noPopup 饹
Ǥޤ

㡧
[[ܤ굻::http://www.emeraldshell.com/||<np>Serene Bach Υץ饰Ƥޤ]]
[[̼̼Ź뤭::http://www.remus.dti.ne.jp/~a-satomi/||<np>֤줳ݥåץåספ줿ߤȤߤΥȤǤ]]
